import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkRechargeLog, ThinkRechargeLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkRechargeLog(params: ThinkRechargeLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkRechargeLog>>>(
    THINK_API_URL + '/think/think-recharge-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkRechargeLog(params?: ThinkRechargeLogParam) {
  const res = await request.get<ApiResult<ThinkRechargeLog[]>>(
    THINK_API_URL + '/think/think-recharge-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkRechargeLog(data: ThinkRechargeLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-recharge-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkRechargeLog(data: ThinkRechargeLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-recharge-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkRechargeLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-recharge-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkRechargeLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-recharge-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkRechargeLog(id: number) {
  const res = await request.get<ApiResult<ThinkRechargeLog>>(
    THINK_API_URL + '/think/think-recharge-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
